////////////////////////////////////////////////////////////////
// Copyright G. Allaire, Juillet 2001
//
// equation de convection
// u,t + Vu,x = 0
//
////////////////////////////////////////////////////////////////

dx = 0.1 ;		// dx = pas d'espace
V = 70;			// vitesse de convection
cfl = 0.9 ;		// cfl
dt = dx*cfl/V ;		// dt = pas de temps.
Tfinal=0.5;		// Temps final souhait.
lg=10;			// Demi-longeur du domaine

nx = 2*lg/dx+1 ; 	// nx = nombre de noeuds
nt = int(Tfinal/dt);	// nt = nombre de pas de temps effectues.

Tfinal=nt*dt;		// Temps final.

//
// initialisation
//

x=linspace(-lg,lg,nx) ;

f0=creneau;
//f0=bosse;


u0=f0(x);

ymax=max(u0);
ymin=min(u0);

u=u0 ;
up=u0 ;
um=u0 ;
uexacte=u0 ;

tics=[4,10,4,10];
rect=[-lg,ymin-0.1,lg,ymax+0.1];

xdel();
xbasc();
plotframe(rect,tics,'donnee initiale');
plot2d(x,u0,1,"000")

title='convection:schema explicite dcentr aval';
halt() ;

////////////////////////////////////////////////////////////////
// schema explicite dcentr aval
////////////////////////////////////////////////////////////////


for n=1:nt
//
up = shiftp('+1',u) ;
um = shiftp('-1',u) ;

u=u -dt*V*(up-u)/dx ;

if modulo(n,5) == 0
        xbasc()
        plotframe(rect,tics,title);
        plot2d(x,u,[1,1],"100","schema dcentr aval");
        uexacte = f0(phase(x-n*dt*V,lg)) ;
	plot2d(x,uexacte,[2,2],"100","solution exacte");

        xpause(100000) ;
end
//
end

